DECLARE SUB DisplayCharacter (iCharacterBuffer() AS INTEGER, iBaseX AS INTEGER, iBaseY AS INTEGER, bClear AS INTEGER)
DECLARE SUB EditCharacter (iCharacterBuffer() AS INTEGER)
DECLARE SUB ShiftCharacterBit (iCharacterBuffer() AS INTEGER, x AS INTEGER, y AS INTEGER)
DECLARE FUNCTION GetCharacterBit% (iCharacterBuffer() AS INTEGER, x AS INTEGER, y AS INTEGER)

CONST True = -1, False = 0

DIM iCharacterBuffer(0 TO 15) AS INTEGER
DIM i AS INTEGER

EditCharacter iCharacterBuffer()
CLS
DisplayCharacter iCharacterBuffer(), 0, 0, False

SUB DisplayCharacter (iCharacterBuffer() AS INTEGER, iBaseX AS INTEGER, iBaseY AS INTEGER, bClear AS INTEGER)

DIM i AS INTEGER, j AS INTEGER
DIM iBitBuffer AS INTEGER

IF bClear THEN
  LINE (iBaseX, iBaseY)-(iBaseX + 16 - 1, iBaseY + 16 - 1), 0, BF
END IF

FOR i = 0 TO 15
  FOR j = 0 TO 15
    IF j < 15 THEN
      iBitBuffer = iCharacterBuffer(i) AND (2 ^ j)
    ELSE
      IF SGN(iCharacterBuffer(i)) = -1 THEN iBitBuffer = 1 ELSE iBitBuffer = 0
    END IF
    IF iBitBuffer <> 0 THEN
      PSET (iBaseX + i, iBaseY + j)
    END IF
  NEXT
NEXT

END SUB

SUB EditCharacter (iCharacterBuffer() AS INTEGER)

DIM x AS INTEGER, y AS INTEGER
DIM kbd AS STRING
DIM iColor AS INTEGER
DIM iBoxSize AS INTEGER
CLS
SCREEN 12
x = 0: y = 0
iBoxSize = 8 ' The size of boxes that represents pixels.
' Draw a boundary.
LINE (16 * iBoxSize, 0)-(16 * iBoxSize, 16 * iBoxSize), 5
LINE (0, 16 * iBoxSize)-(16 * iBoxSize, 16 * iBoxSize), 5
DO
  ' Display Preview.
  DisplayCharacter iCharacterBuffer(), 0, 16 * iBoxSize + 1, True
  ' Draw a box indicating the cursor.
  LINE (x * iBoxSize, y * iBoxSize)-(x * iBoxSize + iBoxSize - 1, y * iBoxSize + iBoxSize - 1), 15, B

  ' Wait for a key stroke.
  DO
    kbd = INKEY$
  LOOP WHILE kbd = ""
  IF kbd = " " THEN
    ShiftCharacterBit iCharacterBuffer(), x, y
    ' Draw a box (black or white) depending on the new bit.
    IF GetCharacterBit(iCharacterBuffer(), x, y) THEN
      iColor = 7 ' White
    ELSE
      iColor = 0 ' Black
    END IF
    LINE (x * iBoxSize, y * iBoxSize)-(x * iBoxSize + iBoxSize - 1, y * iBoxSize + iBoxSize - 1), iColor, BF
  ELSEIF kbd = CHR$(13) THEN
    EXIT DO
  ELSEIF LEN(kbd) = 2 THEN
    ' Draw a box (black or white) before the cursor moves to restore.
    IF GetCharacterBit(iCharacterBuffer(), x, y) THEN
      iColor = 7 ' White
    ELSE
      iColor = 0 ' Black
    END IF
    LINE (x * iBoxSize, y * iBoxSize)-(x * iBoxSize + iBoxSize - 1, y * iBoxSize + iBoxSize - 1), iColor, BF
    SELECT CASE ASC(MID$(kbd, 2))
    CASE 72 ' Up
      y = y - 1
      IF NOT y >= 0 THEN y = 0
    CASE 75 ' Left
      x = x - 1
      IF NOT x >= 0 THEN x = 0
    CASE 77 ' Right
      x = x + 1
      IF NOT x < 16 THEN x = 16 - 1
    CASE 80 ' Down
      y = y + 1
      IF NOT y < 16 THEN y = 16 - 1
    END SELECT
  END IF
LOOP

END SUB

FUNCTION GetCharacterBit% (iCharacterBuffer() AS INTEGER, x AS INTEGER, y AS INTEGER)

DIM i AS INTEGER
IF y < 15 THEN
  i = iCharacterBuffer(x) AND (2 ^ y)
ELSE
  IF SGN(iCharacterBuffer(x)) = -1 THEN i = 1 ELSE i = 0
END IF
IF i <> 0 THEN
  GetCharacterBit% = True
ELSE
  GetCharacterBit% = False
END IF

END FUNCTION

SUB ShiftCharacterBit (iCharacterBuffer() AS INTEGER, x AS INTEGER, y AS INTEGER)

IF y < 15 THEN
  iCharacterBuffer(x) = iCharacterBuffer(x) XOR (2 ^ y)
ELSE
  IF SGN(iCharacterBuffer(x)) >= 0 THEN
    iCharacterBuffer(x) = iCharacterBuffer(x) - 32768
  ELSE
    iCharacterBuffer(x) = iCharacterBuffer(x) + 32768
  END IF
END IF

END SUB

