DECLARE FUNCTION FunctionInterprete! (f AS SINGLE, FuncExpr AS STRING)
DECLARE FUNCTION OnGridX% (i AS INTEGER)
DECLARE FUNCTION OnGridY% (i AS INTEGER)
DECLARE FUNCTION Func% (f AS SINGLE, g AS SINGLE)
DECLARE FUNCTION ScrPos% (i AS INTEGER, j AS INTEGER)
DECLARE SUB ScrSet ()
DIM SHARED fMaxX AS SINGLE, fMaxY AS SINGLE, fMinX AS SINGLE, fMinY AS SINGLE
DIM fDelta AS SINGLE
DIM SHARED fTransX AS SINGLE, fTransY AS SINGLE
DIM SHARED iGrids AS INTEGER, fGridX AS SINGLE, fGridY AS SINGLE
DIM i AS INTEGER, j AS INTEGER, c AS STRING

SCREEN 12
CLS
REM Set the screen variables
CALL ScrSet
CLS

DO
  REM Drawing the function
  i = 0
  DO WHILE i < 639
    DO WHILE ScrPos(i, j) = 0 AND i < 639
      i = i + 1
    LOOP
    PSET (i, j), 7
    DO WHILE ScrPos(i, j) = 1 AND i < 639
      LINE -(i, j), 7
      i = i + 1
    LOOP
  LOOP

  REM Drawing the Grids
  IF iGrids = 1 THEN
    FOR i = 0 TO 639
      IF OnGridX(i) <> 0 THEN LINE (i, 0)-(i, 479), OnGridX(i)
    NEXT
    FOR j = 0 TO 479
      IF OnGridY(j) <> 0 THEN LINE (0, j)-(639, j), OnGridY(j)
    NEXT
  END IF

  REM Accept key information
  DO
    c = INKEY$
    SELECT CASE c
    CASE ".":
      fDelta = (fMaxX - fMinX) / 4
      fMaxX = fMaxX - fDelta
      fMinX = fMinX + fDelta
      fTransX = (fMaxX - fMinX) / 639
      fDelta = (fMaxY - fMinY) / 4
      fMaxY = fMaxY - fDelta
      fMinY = fMinY + fDelta
      fTransY = 479 / (fMaxY - fMinY)
      EXIT DO
    CASE ","
      fDelta = (fMaxX - fMinX) / 2
      fMaxX = fMaxX + fDelta
      fMinX = fMinX - fDelta
      fTransX = (fMaxX - fMinX) / 639
      fDelta = (fMaxY - fMinY) / 2
      fMaxY = fMaxY + fDelta
      fMinY = fMinY - fDelta
      fTransY = 479 / (fMaxY - fMinY)
      EXIT DO
    CASE "a", "A"
      fDelta = (fMaxX - fMinX) * .2
      fMaxX = fMaxX + fDelta
      fMinX = fMinX + fDelta
      EXIT DO
    CASE "w", "W"
      fDelta = (fMaxY - fMinY) * .2
      fMaxY = fMaxY - fDelta
      fMinY = fMinY - fDelta
      EXIT DO
    CASE "d", "D"
      fDelta = (fMaxX - fMinX) * .2
      fMaxX = fMaxX - fDelta
      fMinX = fMinX - fDelta
      EXIT DO
    CASE "x", "X"
      fDelta = (fMaxY - fMinY) * .2
      fMaxY = fMaxY + fDelta
      fMinY = fMinY + fDelta
      EXIT DO
    CASE "g", "G"
      IF iGrids = 0 THEN iGrids = 1 ELSE iGrids = 0
      EXIT DO
    CASE "t", "T"
      fGridX = fGridX * 2
      fGridY = fGridY * 2
      EXIT DO
    CASE "b", "B"
      fGridX = fGridX / 2
      fGridY = fGridY / 2
      EXIT DO
    CASE CHR$(27)
      EXIT DO
    END SELECT
  LOOP

  REM Before redrawing, clear the screen
  CLS
LOOP UNTIL c = CHR$(27)

FUNCTION Func% (f AS SINGLE, g AS SINGLE)

DIM k AS INTEGER

g = f * f
k = 1

Func% = k

END FUNCTION

FUNCTION FunctionInterprete! (f AS SINGLE, FuncExpr AS STRING)

END FUNCTION

FUNCTION OnGridX% (i AS INTEGER)

DIM f AS SINGLE, f1 AS SINGLE
f = fTransX / fGridX
f1 = (i * fTransX + fMinX) / fGridX
IF INT(f1 - f * .5) <> INT(f1 + f * .5) THEN
    OnGridX = 1
    IF (f1 - f * .5) * (f1 + f * .5) < 0 THEN OnGridX = 14
ELSE
    OnGridX = 0
END IF

END FUNCTION

FUNCTION OnGridY% (i AS INTEGER)

DIM f AS SINGLE, f1 AS SINGLE
f = 1 / fTransY / fGridY
f1 = (fMaxY - i / fTransY) / fGridY
IF INT(f1 - f * .5) <> INT(f1 + f * .5) THEN
    OnGridY = 1
    IF (f1 - f * .5) * (f1 + f * .5) < 0 THEN OnGridY = 4
ELSE
    OnGridY = 0
END IF
END FUNCTION

FUNCTION ScrPos% (i AS INTEGER, j AS INTEGER)

DIM k AS INTEGER, h AS SINGLE, f AS SINGLE, g AS SINGLE
f = i * fTransX + fMinX
k = Func(f, g)
REM The screen coordinates are up-side down.
IF k = 1 THEN
  h = (fMaxY - g) * fTransY
  IF h < 0 OR h > 479 THEN k = 0 ELSE j = CINT(h)
END IF
ScrPos% = k

END FUNCTION

SUB ScrSet

DIM c AS STRING
INPUT "Do you want to use the default values? ", c
IF c = "y" OR c = "Y" THEN
  GOSUB UseDefaults
ELSE
  INPUT "Please enter MX, MY, mX, mY: ", fMaxX, fMaxY, fMinX, fMinY
  INPUT "Please enter Grids On/Off, GX, GY: ", iGrids, fGridsX, fGridsY
  REM fMaxX should be larger than fMinX
  IF fMaxX <= fMinX OR fMaxY <= fMinY THEN GOSUB UseDefaults
  IF iGrids <> 0 THEN iGrids = 1
  REM fGridX should be above zero
  IF fGridX <= 0 THEN fGridX = 1
  IF fGridY <= 0 THEN fGridY = 1
END IF
EXIT SUB

UseDefaults:
  fMaxX = 10
  fMaxY = 7.5
  fMinX = -10
  fMinY = -7.5
  iGrids = 0
  fGridX = 1
  fGridY = 1
  fTransX = (fMaxX - fMinX) / 639
  fTransY = 479 / (fMaxY - fMinY)

END SUB

