DECLARE SUB EnlargeByOne ()
DECLARE FUNCTION CalcCylinder& (hdd1 AS ANY, partbl1 AS ANY, intStaEnd AS INTEGER)
DECLARE SUB MainProc ()
DECLARE SUB AnalyseMBR (mbr1 AS ANY)

TYPE PTType
   active AS STRING * 1
   stahead AS STRING * 1
   stasctcyl AS STRING * 2
   systype AS STRING * 1
   endhead AS STRING * 1
   endsctcyl AS STRING * 2
   sctbefore AS STRING * 4
   sctof AS STRING * 4
END TYPE

TYPE MBRType
   bootstrap AS STRING * 446
   partbl1 AS PTType
   partbl2 AS PTType
   partbl3 AS PTType
   partbl4 AS PTType
   vldmark AS STRING * 2
END TYPE

TYPE HDDType
   numcyl AS LONG
   numhead AS LONG
   numsct AS LONG
END TYPE

TYPE SectorPositionType
   cylinder AS LONG
   head AS INTEGER
   sector AS INTEGER
END TYPE

DIM SHARED mhdd1 AS HDDType
'$DYNAMIC
DIM SHARED mbrs(1 TO 1) AS MBRType
DIM SHARED spsPTPositions(1 TO 1) AS SectorPositionType
'$STATIC
DIM SHARED intNumberOfItems AS INTEGER
MainProc
SYSTEM

SUB AnalyseMBR (mbr1 AS MBRType)
   DIM partbl1 AS PTType
   DIM i AS INTEGER
   DIM lngCylinder AS LONG
   DIM intHead AS INTEGER
   DIM intSector AS INTEGER
   DIM dblSector AS DOUBLE
   DIM j AS INTEGER

   FOR i = 1 TO 4
      SELECT CASE i
      CASE 1
         partbl1 = mbr1.partbl1
      CASE 2
         partbl1 = mbr1.partbl2
      CASE 3
         partbl1 = mbr1.partbl3
      CASE 4
         partbl1 = mbr1.partbl4
      END SELECT
      SELECT CASE ASC(partbl1.systype)
      CASE &H0
         PRINT "Empty entry"
      CASE &H1
         PRINT "FAT12 (smaller than 32MB, end not higher than 8GB), MS-DOS"
      CASE &H4
         PRINT "FAT16 (smaller than 32MB, end not higher than 8GB), MS-DOS"
      CASE &H6
         PRINT "FAT16 (smaller than 2GB, end not higher than 8GB), MS-DOS"
      CASE &H7
         PRINT "NTFS/HPFS, Windows NT or OS/2"
      CASE &H8
         PRINT "AIX Bootable Partition, OS/2"
      CASE &H9
         PRINT "AIX Data Partition, OS/2"
      CASE &HA
         PRINT "OS/2 Boot Manager, OS/2"
      CASE &HB
         PRINT "FAT32 (end not higher than 8GB), Windows 9x"
      CASE &HC
         PRINT "FAT32 (end higher than 8GB), Windows 9x"
      CASE &HE
         PRINT "FAT16 (smaller than 2GB, end higher than 8GB), Windows 9x"
      CASE &HF
         PRINT "Extended Partition (end higher than 8GB)"
      CASE &H16
         PRINT "Hidden FAT16 (smaller than 2GB, end not higher than 8GB), MS-DOS"
      CASE &H17
         PRINT "Hidden NTFS, Windows NT"
      CASE &H1B
         PRINT "Hidden FAT32 (end not higher than 8GB), Windows 9x"
      CASE &H1C
         PRINT "Hidden FAT32 (end higher than 8GB), Windows 9x"
      CASE &H1E
         PRINT "Hidden FAT16 (end higher than 8GB), Windows 9x"
      CASE &H42
         PRINT "Dynamic Disk Volume"
      CASE &H50
         PRINT "OnTrack Disk Manager, read-only partition"
      CASE &H51
         PRINT "OnTrack Disk Manager, read/write partition"
      CASE &H81
         PRINT "Linux"
      CASE &H82
         PRINT "Linux Swap partition, Solaris (Unix)"
      CASE &H83
         PRINT "Linux native file system (ext2fs/xiafs)"
      CASE &H85
         PRINT "Linux EXT"
      CASE &H86
         PRINT "FAT16 volumes/stripe set, Windows NT"
      CASE &H87
         PRINT "HPFS fault-tolerant mirrored partition or"
         PRINT "NTFS volume/stripe set, Windows NT"
      CASE &HBE
         PRINT "Solaris boot partition"
      CASE &HC0
         PRINT "DR-DOS/Novell DOS secured partition"
      CASE &HC6
         PRINT "Corrupted FAT16 volume/stripe set, Windows NT"
      CASE &HC7
         PRINT "Corrupted NTFS volume/stripe set, Windows NT"
      CASE &HF2
         PRINT "DOS 3.3+ secondary partition"
      CASE ELSE
         PRINT "Unknown Partition Type "; HEX$(ASC(partbl1.systype))
      END SELECT
      IF ASC(partbl1.systype) <> 0 THEN
         PRINT "Status: ";
         IF ASC(partbl1.active) = &H80 THEN
            PRINT "Active"
         ELSEIF ASC(partbl1.active) = 0 THEN
            PRINT "Normal"
         ELSE
            PRINT "Unrecognised"
         END IF
         lngCylinder = ASC(RIGHT$(partbl1.stasctcyl, 1))
         lngCylinder = lngCylinder + (ASC(partbl1.stasctcyl) \ &H40) * &H100
         PRINT "Starting cylinder (reported):"; lngCylinder; "Or "; HEX$(lngCylinder); " in Hex"
         lngCylinder = CalcCylinder(mhdd1, partbl1, 1)
         PRINT "Starting cylinder (calculated):"; lngCylinder; "Or "; HEX$(lngCylinder); " in Hex"
         intHead = ASC(partbl1.stahead)
         PRINT "Starting head:"; intHead; "Or "; HEX$(intHead); " in Hex"
         intSector = ASC(partbl1.stasctcyl) MOD &H40
         PRINT "Starting sector:"; intSector; "Or "; HEX$(intSector); " in Hex"
         lngCylinder = ASC(RIGHT$(partbl1.endsctcyl, 1))
         lngCylinder = lngCylinder + (ASC(partbl1.endsctcyl) \ &H40) * &H100
         PRINT "Ending cylinder (reported):"; lngCylinder; "Or "; HEX$(lngCylinder); " in Hex"
         lngCylinder = CalcCylinder(mhdd1, partbl1, 2)
         PRINT "Ending cylinder (calculated):"; lngCylinder; "Or "; HEX$(lngCylinder); " in Hex"
         intHead = ASC(partbl1.endhead)
         PRINT "Ending head:"; intHead; "Or "; HEX$(intHead); " in Hex"
         intSector = ASC(partbl1.endsctcyl) MOD &H40
         PRINT "Ending sector:"; intSector; "Or "; HEX$(intSector); " in Hex"
         dblSector = ASC(RIGHT$(partbl1.sctbefore, 1))
         FOR j = 3 TO 1 STEP -1
            dblSector = dblSector * &H100 + ASC(MID$(partbl1.sctbefore, j, 1))
         NEXT
         PRINT "Number of sectors before the partition:"; dblSector
         dblSector = ASC(RIGHT$(partbl1.sctof, 1))
         FOR j = 3 TO 1 STEP -1
            dblSector = dblSector * &H100 + ASC(MID$(partbl1.sctof, j, 1))
         NEXT
         PRINT "Number of sectors of the partition:"; dblSector; "(Size:";
         IF dblSector * 512 > 1073741824 THEN
            PRINT USING "###.##"; dblSector * 512 / 1073741824;
            PRINT " GB";
         ELSEIF dblSector * 512 > 1048576 THEN
            PRINT USING "####.##"; dblSector * 512 / 1048576;
            PRINT " MB";
         ELSE
            PRINT USING "####.##"; dblSector * 512 / 1024;
            PRINT " KB";
         END IF
         PRINT ")"
      END IF
      PRINT
   NEXT
   IF mbr1.vldmark = CHR$(&H55) + CHR$(&HAA) THEN
      PRINT "The MBR is marked valid."
   ELSE
      PRINT "The MBR is invalid."
   END IF
END SUB

FUNCTION CalcCylinder& (hdd1 AS HDDType, partbl1 AS PTType, intStaEnd AS INTEGER)
   DIM dblSector AS DOUBLE
   DIM dblSector2 AS DOUBLE
   DIM i AS INTEGER

   dblSector = ASC(RIGHT$(partbl1.sctbefore, 1))
   FOR i = 3 TO 1 STEP -1
      dblSector = dblSector * &H100 + ASC(MID$(partbl1.sctbefore, i, 1))
   NEXT
   IF intStaEnd = 2 THEN 'Calculating Ending Cylinder
      dblSector2 = ASC(RIGHT$(partbl1.sctof, 1))
      FOR i = 3 TO 1 STEP -1
         dblSector2 = dblSector2 * &H100 + ASC(MID$(partbl1.sctof, i, 1))
      NEXT
      dblSector = dblSector + dblSector2 - 1 'Minus one to create the offset sector number
   END IF
   CalcCylinder& = INT(dblSector / (hdd1.numhead * hdd1.numsct))
END FUNCTION

SUB DefaultHDD
   OPEN "01.hdd" FOR RANDOM AS #1 LEN = LEN(hdd1)
   mhdd1.numcyl = 4982
   mhdd1.numhead = 255
   mhdd1.numsct = 63
   PUT #1, , hdd1
   CLOSE #1
END SUB

SUB EnlargeByOne
   DIM i AS INTEGER
   '$DYNAMIC
   DIM SctPoses(1 TO intNumberOfItems + 1) AS SectorPositionType
   'Copy old items
   FOR i = 1 TO intNumberOfItems
      SctPoses(i) = spsPTPositions(i)
   NEXT
   'Resize the original array (which will cause data loss)
   REDIM spsPTPositions(1 TO intNumberOfItems + 1) AS SectorPositionType
   'Copy back the information
   FOR i = 1 TO intNumberOfItems + 1
      spsPTPositions(i) = SctPoses(i)
   NEXT
   'Do similar things for mbrs
   DIM mbrs1(1 TO intNumberOfItems + 1) AS MBRType
   FOR i = 1 TO intNumberOfItems
      mbrs1(i) = mbrs(i)
   NEXT
   REDIM mbrs(1 TO intNumberOfItems + 1) AS MBRType
   FOR i = 1 TO intNumberOfItems + 1
      mbrs(i) = mbrs1(i)
   NEXT
   intNumberOfItems = intNumberOfItems + 1
END SUB

REM $STATIC
SUB MainProc
   DIM strFileName AS STRING
   DIM intFileNumber AS INTEGER
   DIM i AS INTEGER

   INPUT "Open file: ", strFileName
   PRINT
   intFileNumber = FREEFILE
   'Get HDD information
   OPEN strFileName + ".hdd" FOR RANDOM AS #intFileNumber LEN = LEN(mhdd1)
   GET #intFileNumber, 1, mhdd1
   CLOSE #intFileNumber
   'Get MBR information
   OPEN strFileName + ".mbr" FOR RANDOM AS #intFileNumber LEN = LEN(mbrs(1))
   'Get the number of items first
   i = 1
   DO WHILE NOT EOF(intFileNumber)
      GET #intFileNumber, i, mbrs(1)
      i = i + 1
   LOOP
   i = i - 2 'EOF comes later than the last item does
   intNumberOfItems = i
   REDIM mbrs(1 TO intNumberOfItems) AS MBRType
   FOR i = 1 TO intNumberOfItems
      GET #intFileNumber, i, mbrs(i)
   NEXT
   CLOSE #intFileNumber
   'Get the MBR position table
   REDIM spsPTPositions(1 TO intNumberOfItems) AS SectorPositionType
   OPEN strFileName + ".sps" FOR INPUT AS #intFileNumber
   FOR i = 1 TO intNumberOfItems
      INPUT #1, spsPTPositions(i).cylinder, spsPTPositions(i).head, spsPTPositions(i).sector
   NEXT
   CLOSE #intFileNumber
   AnalyseMBR mbrs(1)
   PRINT "The position of the partition table is: "; spsPTPositions(1).cylinder; spsPTPositions(1).head; spsPTPositions(1).sector
END SUB

SUB WriteToPosition (intCylinder AS LONG, intHead AS INTEGER, intSector AS INTEGER, mbr1 AS MBRType)
   DIM SctPos1 AS SectorPositionType
   FOR i = 1 TO intNumberOfItems
      SctPos1 = spsPTPositions(i)
      IF SctPos1.cylinder = intCylinder AND SctPos1.head = intHead AND SctPos1.sector = intSector THEN
         EXIT FOR
      END IF
   NEXT
   IF i > intNumberOfItems THEN 'Not found
      EnlargeByOne
      'Append the new items
      spsPTPositions(i).cylinder = intCylinder
      spsPTPositions(i).head = intHead
      spsPTPositions(i).sector = intSector
      mbrs(i) = mbr1
   ELSE
   END IF
END SUB

