DECLARE SUB BubbleSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)
DECLARE SUB InsertSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)
DECLARE SUB MergeLists (dSortBuffer() AS DOUBLE, iBaseA AS INTEGER, iBaseB AS INTEGER, iUpperFloaterA AS INTEGER, iUpperFloaterB AS INTEGER, iOutputBase AS INTEGER)
DECLARE SUB SwapLine (dSortBuffer() AS DOUBLE, i AS INTEGER, j AS INTEGER)
DECLARE SUB HeapSortWashOff (dSortBuffer() AS DOUBLE, iStartIndex AS INTEGER, iHeapCount AS INTEGER)
DECLARE SUB HeapSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)
DECLARE SUB Sort (dSortBuffer() AS DOUBLE, iSortMethod AS INTEGER, iCount AS INTEGER)
DECLARE SUB SelectSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)
DECLARE SUB QuickSort (dSortBuffer() AS DOUBLE, iLeft AS INTEGER, iRight AS INTEGER)
DECLARE FUNCTION IntegerLog2% (iNumber AS INTEGER)
DECLARE SUB ShellSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)
DECLARE SUB MergeSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)

CONST True = -1, False = 0

DIM dSortBuffer(0 TO 479) AS DOUBLE
DIM sKeyBoard AS STRING
DIM iSortMethod AS INTEGER

SCREEN 12
RANDOMIZE TIMER
iSortMethod = 0
DO
  CLS
  FOR i = 0 TO 479
    dSortBuffer(i) = RND
  NEXT
  FOR i = 0 TO 479
    LINE (0, i)-(INT(dSortBuffer(i) * 640), i)
  NEXT
  DO
    sKeyBoard = INKEY$
  LOOP UNTIL sKeyBoard = CHR$(13) OR sKeyBoard = CHR$(27)
  IF sKeyBoard = CHR$(27) THEN EXIT DO
  Sort dSortBuffer(), iSortMethod, 480
  DO
    sKeyBoard = INKEY$
  LOOP UNTIL sKeyBoard = CHR$(13) OR sKeyBoard = CHR$(27)
  iSortMethod = iSortMethod + 1
LOOP UNTIL sKeyBoard = CHR$(27)

SUB BubbleSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)

DIM i AS INTEGER, j AS INTEGER
DIM bSwapped AS INTEGER

j = 0
DO
  bSwapped = False
  i = 1
  DO WHILE i < iCount - j
    IF dSortBuffer(i) > dSortBuffer(i - 1) THEN
      SWAP dSortBuffer(i), dSortBuffer(i - 1)
      SwapLine dSortBuffer(), i, i - 1
      bSwapped = True
    END IF
    i = i + 1
  LOOP
  j = j + 1
LOOP WHILE bSwapped

END SUB

SUB HeapSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)

DIM i AS INTEGER
DIM iHeapCount AS INTEGER
DIM bSwapped AS INTEGER

iHeapCount = iCount

' The last non-leaf with children: iCount / 2 - 1
' Two children: (i + 1) * 2; (i + 1) * 2 - 1

i = iCount / 2 - 1
DO WHILE i >= 0
  HeapSortWashOff dSortBuffer(), i, iHeapCount
  i = i - 1
LOOP

' Two steps:
' 1. Swap the first element with the last element.
' 2. Wash off the tree to make the first element the smallest.
' NOTE: The heap is the front part, keep its smallest element on top.

DO WHILE iHeapCount > 1
  SWAP dSortBuffer(0), dSortBuffer(iHeapCount - 1)
  SwapLine dSortBuffer(), 0, iHeapCount - 1
  iHeapCount = iHeapCount - 1
  HeapSortWashOff dSortBuffer(), 0, iHeapCount
LOOP

END SUB

SUB HeapSortWashOff (dSortBuffer() AS DOUBLE, iStartIndex AS INTEGER, iHeapCount AS INTEGER)

DIM bSwapped AS INTEGER
DIM i AS INTEGER, j AS INTEGER
i = iStartIndex

DO
  bSwapped = False
  j = (i + 1) * 2
  IF j < iHeapCount THEN
    IF dSortBuffer(j) < dSortBuffer(i) THEN
      IF dSortBuffer(j - 1) < dSortBuffer(j) THEN
        SWAP dSortBuffer(j - 1), dSortBuffer(i)
        SwapLine dSortBuffer(), j - 1, i
        bSwapped = True
        i = j - 1
      ELSE
        SWAP dSortBuffer(j), dSortBuffer(i)
        SwapLine dSortBuffer(), j, i
        bSwapped = True
        i = j
      END IF
    ELSEIF dSortBuffer(j - 1) < dSortBuffer(i) THEN
      SWAP dSortBuffer(j - 1), dSortBuffer(i)
      SwapLine dSortBuffer(), j - 1, i
      bSwapped = True
      i = j - 1
    END IF
  ELSEIF j - 1 < iHeapCount THEN
    IF dSortBuffer(j - 1) < dSortBuffer(i) THEN
      SWAP dSortBuffer(j - 1), dSortBuffer(i)
      SwapLine dSortBuffer(), j - 1, i
      bSwapped = True
      i = j - 1
    END IF
  END IF
LOOP WHILE bSwapped

END SUB

SUB InsertSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)

DIM i AS INTEGER
DIM j AS INTEGER

i = 1
DO WHILE i < iCount
  j = i
  DO WHILE j >= 1
    IF dSortBuffer(j - 1) < dSortBuffer(j) THEN
      SWAP dSortBuffer(j - 1), dSortBuffer(j)
      SwapLine dSortBuffer(), j - 1, j
    END IF
    j = j - 1
  LOOP
  i = i + 1
LOOP

END SUB

FUNCTION IntegerLog2% (iNumber AS INTEGER)

DIM i AS INTEGER
DIM iNumberBuffer AS INTEGER
i = 0: iNumberBuffer = iNumber
DO WHILE iNumberBuffer > 1
  iNumberBuffer = iNumberBuffer \ 2
  i = i + 1
LOOP
IntegerLog2% = i

END FUNCTION

SUB MergeLists (dSortBuffer() AS DOUBLE, iBaseA AS INTEGER, iBaseB AS INTEGER, iUpperFloaterA AS INTEGER, iUpperFloaterB AS INTEGER, iOutputBase AS INTEGER)

DIM i AS INTEGER, j AS INTEGER, k AS INTEGER
i = iBaseA: j = iBaseB: k = iOutputBase
DO WHILE i < iUpperFloaterA AND j < iUpperFloaterB
  IF dSortBuffer(i) >= dSortBuffer(j) THEN
    dSortBuffer(k) = dSortBuffer(i)
    i = i + 1
  ELSE
    dSortBuffer(k) = dSortBuffer(j)
    j = j + 1
  END IF
  k = k + 1
LOOP

DO WHILE i < iUpperFloaterA
  dSortBuffer(k) = dSortBuffer(i)
  i = i + 1: k = k + 1
LOOP

DO WHILE j < iUpperFloaterB
  dSortBuffer(k) = dSortBuffer(j)
  j = j + 1: k = k + 1
LOOP

END SUB

SUB MergeSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)

DIM dLargerSortBuffer(0 TO 959) AS DOUBLE
DIM iSourceBase AS INTEGER
DIM iTargetBase AS INTEGER
DIM iRepeats AS INTEGER
DIM iStep AS INTEGER
DIM i AS INTEGER, j AS INTEGER, k AS INTEGER
i = 0
DO WHILE i < iCount
  dLargerSortBuffer(i) = dSortBuffer(i)
  i = i + 1
LOOP

iSourceBase = 0: iTargetBase = iCount
iStep = 2
DO WHILE iStep \ 2 < iCount
  iRepeats = 0
  DO
    i = iSourceBase + iRepeats * iStep
    j = iSourceBase + iRepeats * iStep + iStep \ 2
    k = iSourceBase + iRepeats * iStep + iStep
    IF k > iSourceBase + iCount THEN
      ' Requires compromisation.
      IF j < iSourceBase + iCount THEN
        ' Still requires merging.
        k = iSourceBase + iCount
      ELSEIF i < iSourceBase + iCount THEN
        ' Requires copying.
        j = iSourceBase + iCount
        k = iSourceBase + iCount
      ELSE
        EXIT DO
      END IF
    END IF
    MergeLists dLargerSortBuffer(), i, j, j, k, iTargetBase + iRepeats * iStep
    iRepeats = iRepeats + 1
  LOOP
  iStep = iStep * 2
  SWAP iSourceBase, iTargetBase
  i = 0
  DO WHILE i < iCount
    dSortBuffer(i) = dLargerSortBuffer(iSourceBase + i)
    LINE (0, i)-(639, i), 0
    LINE (0, i)-(INT(640 * dSortBuffer(i)), i)
    i = i + 1
  LOOP
LOOP

i = 0
DO WHILE i < iCount
  dSortBuffer(i) = dLargerSortBuffer(iSourceBase + i)
  LINE (0, i)-(639, i), 0
  LINE (0, i)-(INT(640 * dSortBuffer(i)), i)
  i = i + 1
LOOP

END SUB

SUB QuickSort (dSortBuffer() AS DOUBLE, iLeft AS INTEGER, iRight AS INTEGER)

IF iLeft >= iRight THEN EXIT SUB

DIM i AS INTEGER, j AS INTEGER
DIM dPivotKey AS DOUBLE

j = iLeft + INT(RND * (1 + iRight - iLeft))

SWAP dSortBuffer(iLeft), dSortBuffer(j)
SwapLine dSortBuffer(), iLeft, j
dPivotKey = dSortBuffer(iLeft)
i = iLeft
j = iRight
DO
  DO WHILE i < j
    IF dSortBuffer(j) >= dPivotKey THEN EXIT DO
    j = j - 1
  LOOP
  IF NOT i < j THEN EXIT DO
  ' [i] is a pivotKey
  IF dSortBuffer(j) = dPivotKey THEN ' both [i] and [j] are pivotKeys
    ' at least shorten the range by 1
    i = i + 1
  ELSE
    SWAP dSortBuffer(i), dSortBuffer(j)
    SwapLine dSortBuffer(), i, j
  END IF
  ' now [j] is a pivotKey
  DO WHILE i < j
    IF dSortBuffer(i) <= dPivotKey THEN EXIT DO
    i = i + 1
  LOOP
  IF NOT i < j THEN EXIT DO
  IF dSortBuffer(i) = dPivotKey THEN
    j = j - 1
  ELSE
    SWAP dSortBuffer(i), dSortBuffer(j)
    SwapLine dSortBuffer(), i, j
  END IF
LOOP
QuickSort dSortBuffer(), iLeft, i - 1
QuickSort dSortBuffer(), i + 1, iRight

END SUB

SUB SelectSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)

DIM i AS INTEGER, j AS INTEGER
DIM dMax AS DOUBLE, iMaxIndex AS INTEGER
i = 0
DO WHILE i < iCount
  dMax = dSortBuffer(i)
  iMaxIndex = i
  j = i + 1
  DO WHILE j < iCount
    IF dMax < dSortBuffer(j) THEN
      dMax = dSortBuffer(j)
      iMaxIndex = j
    END IF
    j = j + 1
  LOOP
  SWAP dSortBuffer(i), dSortBuffer(iMaxIndex)
  SwapLine dSortBuffer(), i, iMaxIndex
  i = i + 1
LOOP

END SUB

SUB ShellSort (dSortBuffer() AS DOUBLE, iCount AS INTEGER)

DIM i AS INTEGER
DIM stepper AS INTEGER
DIM iDelta AS INTEGER
DIM bSwapped AS INTEGER

stepper = 0
DO
  IF 2 ^ stepper >= iCount \ 2 THEN EXIT DO
  stepper = stepper + 1
LOOP
iDelta = 2 ^ stepper - 1
DO WHILE iDelta >= 1
  DO
    bSwapped = False
    i = 0
    DO WHILE i < iCount - iDelta
      IF dSortBuffer(i) < dSortBuffer(i + iDelta) THEN
        SWAP dSortBuffer(i), dSortBuffer(i + iDelta)
        SwapLine dSortBuffer(), i, i + iDelta
        bSwapped = True
      END IF
      i = i + 1
    LOOP
  LOOP WHILE bSwapped
  iDelta = (iDelta + 1) \ 2 - 1
LOOP

END SUB

SUB Sort (dSortBuffer() AS DOUBLE, iSortMethod AS INTEGER, iCount AS INTEGER)

SELECT CASE iSortMethod MOD 7
CASE 0
  QuickSort dSortBuffer(), 0, iCount - 1
CASE 1
  HeapSort dSortBuffer(), iCount
CASE 2
  SelectSort dSortBuffer(), iCount
CASE 3
  BubbleSort dSortBuffer(), iCount
CASE 4
  InsertSort dSortBuffer(), iCount
CASE 5
  ShellSort dSortBuffer(), iCount
CASE 6
  MergeSort dSortBuffer(), iCount
END SELECT

END SUB

SUB SwapLine (dSortBuffer() AS DOUBLE, i AS INTEGER, j AS INTEGER)

LINE (0, i)-(639, i), 0
LINE (0, j)-(639, j), 0
LINE (0, i)-(INT(640 * dSortBuffer(i)), i)
LINE (0, j)-(INT(640 * dSortBuffer(j)), j)

END SUB

